package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.entity.MerchantWithdraw;
import com.gxwebsoft.shop.param.MerchantWithdrawParam;
import com.gxwebsoft.shop.service.MerchantWithdrawService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商户提现记录控制器
 *
 * @author 科技小王子
 * @since 2022-12-02 00:41:09
 */
@Api(tags = "商户提现记录管理")
@RestController
@RequestMapping("/api/shop/merchant-withdraw")
public class MerchantWithdrawController extends BaseController {
    @Resource
    private MerchantWithdrawService merchantWithdrawService;

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:list')")
    @OperationLog
    @ApiOperation("分页查询商户提现记录")
    @GetMapping("/page")
    public ApiResult<PageResult<MerchantWithdraw>> page(MerchantWithdrawParam param) {
        // 使用关联查询
        return success(merchantWithdrawService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:list')")
    @OperationLog
    @ApiOperation("查询全部商户提现记录")
    @GetMapping()
    public ApiResult<List<MerchantWithdraw>> list(MerchantWithdrawParam param) {
        return success(merchantWithdrawService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:list')")
    @OperationLog
    @ApiOperation("根据id查询商户提现记录")
    @GetMapping("/{id}")
    public ApiResult<MerchantWithdraw> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(merchantWithdrawService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:save')")
    @OperationLog
    @ApiOperation("添加商户提现记录")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MerchantWithdraw merchantWithdraw) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          merchantWithdraw.setUserId(loginUser.getUserId());
        }
        if (merchantWithdrawService.save(merchantWithdraw)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:update')")
    @OperationLog
    @ApiOperation("修改商户提现记录")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MerchantWithdraw merchantWithdraw) {
        if (merchantWithdrawService.updateById(merchantWithdraw)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:remove')")
    @OperationLog
    @ApiOperation("删除商户提现记录")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (merchantWithdrawService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:save')")
    @OperationLog
    @ApiOperation("批量添加商户提现记录")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MerchantWithdraw> list) {
        if (merchantWithdrawService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:update')")
    @OperationLog
    @ApiOperation("批量修改商户提现记录")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MerchantWithdraw> batchParam) {
        if (batchParam.update(merchantWithdrawService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:merchantWithdraw:remove')")
    @OperationLog
    @ApiOperation("批量删除商户提现记录")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (merchantWithdrawService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
